# Pull Request Template

## Description

Please include a summary of the change and which issue is fixed. Please also include relevant motivation and context. List any dependencies that are required for this change.

Fixes # (issue)

## Type of change

Please delete options that are not relevant.

- [ ] Bug fix (non-breaking change which fixes an issue)
- [ ] New feature (non-breaking change which adds functionality)
- [ ] Breaking change (fix or feature that would cause existing functionality to not work as expected)
- [ ] This change requires a documentation update

## How Has This Been Tested?



## Checklist:

### Must:
- [ ] I have run `format.sh` under `script`
- [ ] I have performed a self-**review** of my own code
- [ ] I have **comment**ed my code, particularly in hard-to-understand areas
- [ ] New and existing unit tests pass locally with my changes

### Semi-Must
- [ ] I have added new tests that prove my fix is effective or that my feature works
- [ ] I have checked my code and corrected any **misspellings**

### Optional:
- [ ] My code follows the [**style guidelines**](https://docs.hstream.io/development/haskell-style/) of this project
- [ ] I have made corresponding changes to the documentation
- [ ] My changes generate no new warnings
- [ ] Any dependent changes have been merged and published in downstream modules
